/***************************************************************************
                          optimizer.h  -  description
                             -------------------
    begin                : Sat Jul 28 2001
    copyright            : (C) 2001 by Chris Wallace
    email                : ranchhard@netflash.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OPTIMIZER_H
#define OPTIMIZER_H

#include <stack>
//using namespace std;
/**
  *@author Chris Wallace
  */

class Optimizer {
	public:
		enum TagType {Bold=0,
									Emphasis,
									Italic,
									Plain,
									Strong,
									Typewriter,
									Underline,
									Size0,
									Size1,
									Size2,
									Size3,
									Size4,
									Size5,
									Size6,
									Size7,
									Size8,
									Size9,
									Red,
									Green,
									Blue,
									Cyan,
									Magenta,
									Yellow,
									Black,
									White,
									UnknownTag};
									
		Optimizer();
		Optimizer(const Optimizer &);
		~Optimizer();
		void operator = (const Optimizer &);
	
		bool optimize(void);
		
	protected:
		bool parseText(void);
		bool parseTag(void);
		bool parseDocument(void);
		bool isSpaceCharacter(char ch);
		//bool inTypewriter(void) {return inTT;}
		bool lookahead(const TagType & tt);
		bool lookahead(const TagType & tt, bool escape);
		Optimizer::TagType getTagType(char l1, char l2);
		void printTag(TagType tt, bool escape);
		
		bool emElimination(bool escape);
		
	private:
		/*bool inTT;
		bool inBold;
		bool ignoreBold;
		bool inItalic;
		bool inEmphasis;
		bool inStrong;
		*/
		
		unsigned int mDoc;
		
		unsigned int mBold;
		unsigned int mItalic;
		bool mEmphasis;
		unsigned int mStrong;
		unsigned int mTypewriter;
};

#endif
